//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Market Info
// version - 1.0.1
// Author - CyberPunk
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
/*       MarketInfo().
          ,   
 .
          *.csv /
*.htm . */
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//  
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//-----------------------------------------------------------------------------
//  
//-----------------------------------------------------------------------------

/* Copyright */
#property copyright "Copyright \xa9 2009, CyberPunk"

/*     */
#property show_inputs

//-----------------------------------------------------------------------------
//  
//-----------------------------------------------------------------------------

/*    */
#include <stderror.mqh>

/*    */
#include <stdlib.mqh>

/*      Windows */
#include <WinUser32.mqh>

//-----------------------------------------------------------------------------
//  
//-----------------------------------------------------------------------------

/*   */
extern string ev_Symbol = "";

/*      :
   false -    Alert();
   true -    MessageBox(); */
extern bool ev_MsgType = true;

/*   ( )   */
extern string ev_FileName = "Market Info";

/* ,  ,    *.csv  */
extern bool ev_PrintCsvFile = false;

/* ,  ,    *.htm  */
extern bool ev_PrintHtmlFile = false;

//-----------------------------------------------------------------------------
//  
//-----------------------------------------------------------------------------

/*      MarketInfo() */
string pa_Descriptions[28] = 
  {
   "  ",
   "  ",
   "   ",
   "    (Bid)",
   "    (Ask)",
   "     (Point)",
   "        ",
   "   (Spread)",
   "   -/-   (StopLevel)",
   "     ",
   "       ",
   "       ",
   "    ",
   "    ",
   "    (   )",
   "    (   )",
   "     ",
   "  ",
   "  ",
   "  ",
   "  ",
   "  ",
   "   ",
   "     ",
   "           ",
   ",         ",
   "  ,       ",
//     .      ,   ,      ,   
   "    "
  };

/*     MarketInfo() */
string pa_Values[28];

/*    */
string pv_BrokerName[2] = {"  : "};

/*    */
string pv_ServerName[2] = {"  : "};

/*   */
string pv_LocalTime[2] = {" : "};



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//  
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//-----------------------------------------------------------------------------
//   start()
//-----------------------------------------------------------------------------
void start()
  {
   if (pf_InitValues())                      //   
     {
      pf_PrintScreen();                      //    
      if (ev_PrintCsvFile) pf_PrintCsv();    //  csv-
      if (ev_PrintHtmlFile) pf_PrintHtml();  //  html-
     }
  }



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//  
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

//-----------------------------------------------------------------------------
//  pf_InitValues()
//-----------------------------------------------------------------------------
/*     , ,  
,     */
//-----------------------------------------------------------------------------
bool pf_InitValues()
  {
   bool Rez = false;                         //  
   //    ,    
   if (ev_Symbol == "") ev_Symbol = Symbol();
   GetLastError();                           //     
//-----------------------------
/*    ,     MarketInfo(), 
GetLastError()    */
//-----------------------------
   MarketInfo(ev_Symbol, MODE_POINT);
   if (GetLastError() == ERR_UNKNOWN_SYMBOL) //     
      // 
      Alert(" ", ev_Symbol, "  !");
   else                                      //  
     {
      //  (   )    
      int lv_Digits = MarketInfo(ev_Symbol, MODE_DIGITS);
      int lv_TempInt;                        //    double >> int
      Rez = true;                            //  
      pv_BrokerName[1] = AccountCompany();   //    
      pv_ServerName[1] = AccountServer();    //    
      //   
      pv_LocalTime[1] = TimeToStr(TimeLocal(), TIME_DATE | TIME_SECONDS);
//-----------------------------
/*     MarketInfo() */
//-----------------------------
      pa_Values[0] = DoubleToStr(MarketInfo(ev_Symbol, MODE_LOW), lv_Digits);
      pa_Values[1] = DoubleToStr(MarketInfo(ev_Symbol, MODE_HIGH), lv_Digits);
      pa_Values[2] = TimeToStr(MarketInfo(ev_Symbol, MODE_TIME), TIME_DATE | TIME_SECONDS);
      pa_Values[3] = DoubleToStr(MarketInfo(ev_Symbol, MODE_BID), lv_Digits);
      pa_Values[4] = DoubleToStr(MarketInfo(ev_Symbol, MODE_ASK), lv_Digits);
      pa_Values[5] = DoubleToStr(MarketInfo(ev_Symbol, MODE_POINT), lv_Digits);
      pa_Values[6] = lv_Digits;
      lv_TempInt = MarketInfo(ev_Symbol, MODE_SPREAD);
      pa_Values[7] = lv_TempInt;
      lv_TempInt = MarketInfo(ev_Symbol, MODE_STOPLEVEL);
      pa_Values[8] = lv_TempInt;
      pa_Values[9] = DoubleToStr(MarketInfo(ev_Symbol, MODE_LOTSIZE), 2);
      pa_Values[10] = MarketInfo(ev_Symbol, MODE_TICKVALUE);
      pa_Values[11] = MarketInfo(ev_Symbol, MODE_TICKSIZE);
      pa_Values[12] = MarketInfo(ev_Symbol, MODE_SWAPLONG);
      pa_Values[13] = MarketInfo(ev_Symbol, MODE_SWAPSHORT);
      pa_Values[14] = TimeToStr(MarketInfo(ev_Symbol, MODE_STARTING), TIME_DATE | TIME_SECONDS);
      pa_Values[15] = TimeToStr(MarketInfo(ev_Symbol, MODE_EXPIRATION), TIME_DATE | TIME_SECONDS);
      if (MarketInfo(ev_Symbol, MODE_TRADEALLOWED) == 1.0) pa_Values[16] = "";
      else pa_Values[16] = "";
      pa_Values[17] = MarketInfo(ev_Symbol, MODE_MINLOT);
      pa_Values[18] = MarketInfo(ev_Symbol, MODE_LOTSTEP);
      pa_Values[19] = MarketInfo(ev_Symbol, MODE_MAXLOT);
      switch (MarketInfo(ev_Symbol, MODE_SWAPTYPE))
        {
         case 0.0: pa_Values[20] = " "; break;
         case 1.0: pa_Values[20] = "   "; break;
         case 2.0: pa_Values[20] = " "; break;
         case 3.0: pa_Values[20] = "   ";
        }
      switch (MarketInfo(ev_Symbol, MODE_PROFITCALCMODE))
        {
         case 0.0: pa_Values[21] = "Forex"; break;
         case 1.0: pa_Values[21] = "CFD"; break;
         case 2.0: pa_Values[21] = "Futures";
        }
      switch (MarketInfo(ev_Symbol, MODE_MARGINCALCMODE))
        {
         case 0.0: pa_Values[22] = "Forex"; break;
         case 1.0: pa_Values[22] = "CFD"; break;
         case 2.0: pa_Values[22] = "Futures"; break;
         case 3.0: pa_Values[22] = "CFD  ";
        }
      pa_Values[23] = MarketInfo(ev_Symbol, MODE_MARGININIT);
      pa_Values[24] = MarketInfo(ev_Symbol, MODE_MARGINMAINTENANCE);
      pa_Values[25] = MarketInfo(ev_Symbol, MODE_MARGINHEDGED);
      pa_Values[26] = MarketInfo(ev_Symbol, MODE_MARGINREQUIRED);
      lv_TempInt = MarketInfo(ev_Symbol, MODE_FREEZELEVEL);
      pa_Values[27] = lv_TempInt;
     }
   return(Rez);                              //  
  }

//-----------------------------------------------------------------------------
//  pf_PrintScreen()
//-----------------------------------------------------------------------------
/*        Alert(), 
MessageBox() */
//-----------------------------------------------------------------------------
void pf_PrintScreen()
  {
   //   
   string lv_Msg = StringConcatenate(
      " ",
      "\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~",
      "\n", pv_BrokerName[0], pv_BrokerName[1],
      "\n", pv_ServerName[0], pv_ServerName[1],
      "\n: ", ev_Symbol,
      "\n", pv_LocalTime[0], pv_LocalTime[1],
      "\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
   //    
   for (int i = 0; i <= 27; i++)
      lv_Msg = StringConcatenate(lv_Msg, "\n", pa_Descriptions[i], ": ", pa_Values[i]);
   //    
   if (ev_MsgType) MessageBox(lv_Msg, " ", MB_ICONINFORMATION);
   else Alert(lv_Msg);
  }

//-----------------------------------------------------------------------------
//  pf_PrintCsv()
//-----------------------------------------------------------------------------
/*        */
//-----------------------------------------------------------------------------
void pf_PrintCsv()
  {
   //   
   int handle = FileOpen(ev_FileName + ".csv", FILE_CSV | FILE_WRITE);
   //         
   if (handle == -1) pf_FileOpenErr(ev_FileName + ".csv");
   else                                      //    ,     
     {
      FileWrite(handle, " ");
      FileWrite(handle,"");                  //  
      FileWrite(handle, pv_BrokerName[0], pv_BrokerName[1]);
      FileWrite(handle, pv_ServerName[0], pv_ServerName[1]);
      FileWrite(handle, ": ", ev_Symbol);
      FileWrite(handle, pv_LocalTime[0], pv_LocalTime[1]);
      FileWrite(handle,"");                  //  
      FileWrite(handle, "", "");
      for (int i = 0; i <= 27; i++)          //    
         FileWrite(handle, pa_Descriptions[i], pa_Values[i]);
      FileWrite(handle, "");                 //  
      // Copyright
      FileWrite(handle, "Generated by MQL4 script \"Market Info\"", "Copyright \xa9 2009, CyberPunk");
      FileClose(handle);                     //  
     }
  }

//-----------------------------------------------------------------------------
//  pf_PrintHtml()
//-----------------------------------------------------------------------------
/*      html  */
//-----------------------------------------------------------------------------
void pf_PrintHtml()
  {
   //   
   int handle = FileOpen(ev_FileName + ".htm", FILE_BIN | FILE_WRITE);
   if (handle != -1)                         //    
     {
//-----------------------------
/*  html    ,      */
//-----------------------------
      //   
      string lv_HtmlFile = StringConcatenate(
         "<html>",
         "\r\n<head>",
         "\r\n\t<meta http-equiv=\"content-type\" content=\"text/html; charset=Windows-1251\">",
         "\r\n\t<meta name=\"generator\" content=\"MQL4 script &quot;Market Info&quot;. Copyright &copy; 2009, CyberPunk\">",
         "\r\n\t<title> </title>",
         "\r\n</head>",
         "\r\n<body bgcolor=\"LightSteelBlue\">",
         "\r\n\t<h2 align=\"center\"> </h2>",
         "\r\n\t<hr size=\"4\">",
         "\r\n\t<ul>",
         "\r\n\t\t<li>", pv_BrokerName[0], pv_BrokerName[1], "</li>",
         "\r\n\t\t<li>", pv_ServerName[0], pv_ServerName[1], "</li>",
         "\r\n\t\t<li>: ", ev_Symbol, "</li>",
         "\r\n\t\t<li>", pv_LocalTime[0], pv_LocalTime[1], "</li>",
         "\r\n\t</ul>",
         "\r\n\t<hr size=\"4\">",
         "\r\n\t<table border=\"4\" align=\"center\" width=\"85%\">",
         "\r\n\t\t<tr><th></th><th></th></tr>");
      for (int i = 0; i <= 27; i++)          //  
         lv_HtmlFile = StringConcatenate(lv_HtmlFile, "\r\n\t\t<tr><td>", pa_Descriptions[i], "</td><td>", pa_Values[i], "</td></tr>");
      //   
      lv_HtmlFile = StringConcatenate(lv_HtmlFile,
         "\r\n\t</table>",
         "\r\n\t<hr size=\"4\">",
         "\r\n\t<address style=\"text-align: right\">Generated by MQL4 script &quot;Market Info&quot;. Copyright &copy; 2009, CyberPunk</address>",
         "\r\n</body>",
         "\r\n</html>");
      //  
      FileWriteString(handle, lv_HtmlFile, StringLen(lv_HtmlFile));
      FileClose(handle);                     //  
     }
   //      ,    
   else pf_FileOpenErr(ev_FileName + ".htm");
  }

//-----------------------------------------------------------------------------
//  pf_FileOpenErr()
//-----------------------------------------------------------------------------
/*       */
//-----------------------------------------------------------------------------
void pf_FileOpenErr(string fp_FileName)
  {
   int lv_Err = GetLastError();              //   
   Alert(                                    //   
      "    \"", fp_FileName, "\"!\n",
      " : ", lv_Err, " (", ErrorDescription(lv_Err), ")"
   );
  }